## notcurses 2.1.7+dfsg.1

=== CMakeLists.txt ===
# 3.14.0 introduced NAME_WLE
cmake_minimum_required(VERSION 3.14.0)
project(notcurses VERSION 2.1.7
  DESCRIPTION "Blingful UI for modern terminal emulators"
  HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
  LANGUAGES C CXX)
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_C_STANDARD 11)
set(CMAKE_C_VISIBILITY_PRESET hidden)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_VISIBILITY_PRESET hidden)

include(CTest)
include(GNUInstallDirs)
include(CMakeDependentOption)
include(FeatureSummary)

###################### USER-SELECTABLE OPTIONS ###########################
# BUILD_TESTING is defined by CTest
option(DFSG_BUILD "DFSG build (no non-free media/code)" OFF)
option(USE_COVERAGE "Assess code coverage with llvm-cov/lcov" OFF)
cmake_dependent_option(
  USE_DOCTEST "Build notcurses-tester with doctest" ON
  "${BUILD_TESTING}" OFF
)
option(USE_DOXYGEN "Build HTML cross reference with doxygen" OFF)
option(USE_PANDOC "Build man pages and HTML reference with pandoc" ON)
option(USE_POC "Build small, uninstalled proof-of-concept binaries" ON)
option(USE_QRCODEGEN "Disable libqrcodegen QR code support" ON)
option(USE_STATIC "Build static libraries (in addition to shared)" ON)
set(USE_MULTIMEDIA "ffmpeg" CACHE STRING "Multimedia engine, one of 'ffmpeg', 'oiio', or 'none'")
set_property(CACHE USE_MULTIMEDIA PROPERTY STRINGS ffmpeg oiio none)
set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS Debug Release MinSizeRel RelWithDebInfo Coverage)
############## END (additional) USER-SELECTABLE OPTIONS ##################
set(USE_FFMPEG OFF)
set(USE_OIIO OFF)
if(${USE_MULTIMEDIA} STREQUAL "ffmpeg")
  set(USE_FFMPEG ON)
elseif(${USE_MULTIMEDIA} STREQUAL "oiio")
  set(USE_OIIO ON)
elseif(NOT ${USE_MULTIMEDIA} STREQUAL "none")
  message(FATAL_ERROR "USE_MULTIMEDIA must be one of 'oiio', 'ffmpeg', 'none' (was '${USE_MULTIMEDIA}')")
endif()

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
    STRING "Choose the build mode." FORCE)
endif()
string(APPEND CMAKE_C_FLAGS_DEBUG " -O0")
string(APPEND CMAKE_CXX_FLAGS_DEBUG " -O0")
if("${USE_COVERAGE}")
  if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")
  endif()
  if(NOT "${CMAKE_CXX_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
    message(FATAL_ERROR "USE_COVERAGE was on but CXX isn't clang++")
  endif()
  # FIXME requires clang11+
  string(APPEND CMAKE_C_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
  string(APPEND CMAKE_CXX_FLAGS_DEBUG " --coverage -fprofile-instr-generate -fcoverage-mapping")
endif()

if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
set(PKGCONFIG_DIR "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
else()
set(PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/libdata/pkgconfig")
endif()

# global compiler flags
add_compile_definitions(FORTIFY_SOURCE=2)
add_compile_options(-Wall -Wextra -W -Wshadow -Wformat -fexceptions)

message(STATUS "Requested multimedia engine: ${USE_MULTIMEDIA}")
message(STATUS "Requested build mode: ${CMAKE_BUILD_TYPE}")

find_package(PkgConfig REQUIRED)
# don't use REQUIRED with subsequent find_package() operations; we use
# feature_summary + set_package_properties to fail in one fell swoop.
find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)
# some distros (<cough>motherfucking alpine</cough> subsume terminfo directly
# into ncurses. accept either, and may god have mercy on our souls.
pkg_search_module(TERMINFO REQUIRED tinfo>=6.1 ncursesw>=6.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND terminfo)
set_package_properties(terminfo PROPERTIES TYPE REQUIRED)
pkg_search_module(READLINE REQUIRED readline>=8.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND readline)
set_package_properties(readline PROPERTIES TYPE REQUIRED)
if(${USE_FFMPEG})
pkg_check_modules(AVCODEC REQUIRED libavcodec>=57.0)
pkg_check_modules(AVFORMAT REQUIRED libavformat>=57.0)
pkg_check_modules(AVUTIL REQUIRED libavutil>=56.0)
pkg_check_modules(SWSCALE REQUIRED libswscale>=5.0)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND FFMpeg)
elseif(${USE_OIIO})
pkg_check_modules(OIIO REQUIRED OpenImageIO>=2.1)
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND OpenImageIO)
endif()
find_library(MATH_LIBRARIES m)
if(${USE_DOCTEST})
find_package(doctest 2.3.5)
set_package_properties(doctest PROPERTIES TYPE REQUIRED)
endif()

# don't cache these, or installing them requires clearing the cache to be found.
# this is going to be true for anything lacking pkg-config/CMake support.
unset(HAVE_UNISTRING_H CACHE)
check_include_file("uniwbrk.h" HAVE_UNISTRING_H)
if(NOT "${HAVE_UNISTRING_H}")
  message(FATAL_ERROR "Couldn't find uniwbrk.h from GNU libunistring")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND libunistring)
set_package_properties(libunistring PROPERTIES TYPE REQUIRED)
unset(HAVE_QRCODEGEN_H CACHE)
if("${USE_QRCODEGEN}")
check_include_file("qrcodegen/qrcodegen.h" HAVE_QRCODEGEN_H)
if(NOT "${HAVE_QRCODEGEN_H}")
  message(FATAL_ERROR "USE_QRCODEGEN is active, but couldn't find qrcodegen.h")
endif()
set_property(GLOBAL APPEND PROPERTY PACKAGES_FOUND qrcodegen)
endif()
find_library(LIBRT rt)
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

file(GLOB COMPATSRC CONFIGURE_DEPENDS src/compat/compat.c)

############################################################################
# libnotcurses-core (core shared library, core static library)
file(GLOB NCCORESRCS CONFIGURE_DEPENDS src/lib/*.c src/lib/*.cpp)
add_library(notcurses-core SHARED ${NCCORESRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-core-static STATIC ${NCCORESRCS})
else()
add_library(notcurses-core-static STATIC EXCLUDE_FROM_ALL ${NCCORESRCS})
endif()
set_target_properties(notcurses-core PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-core-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses-core
)
target_include_directories(notcurses-core
  PRIVATE
    include
    src
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
    "${READLINE_INCLUDE_DIRS}"
)
target_include_directories(notcurses-core-static
  PRIVATE
    include
    src
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_STATIC_INCLUDE_DIRS}"
    "${READLINE_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses-core
  PRIVATE
    "${TERMINFO_LIBRARIES}"
    "${READLINE_LIBRARIES}"
    "${LIBRT}"
    unistring
  PUBLIC
    Threads::Threads
)
target_link_libraries(notcurses-core-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARIES}"
    "${READLINE_STATIC_LIBRARIES}"
    "${LIBRT}"
    unistring
  PUBLIC
    Threads::Threads
)
target_link_directories(notcurses-core
  PRIVATE
    "${TERMINFO_LIBRARY_DIRS}"
    "${READLINE_LIBRARY_DIRS}"
)
target_link_directories(notcurses-core-static
  PRIVATE
    "${TERMINFO_STATIC_LIBRARY_DIRS}"
    "${READLINE_STATIC_LIBRARY_DIRS}"
)
# don't want these on freebsd/dragonfly/osx
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
target_compile_definitions(notcurses-core
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
target_compile_definitions(notcurses-core-static
  PUBLIC
   _XOPEN_SOURCE=700 # wcwidth(3) requires _XOPEN_SOURCE, and is in our headers
  PRIVATE
   _GNU_SOURCE _DEFAULT_SOURCE
)
endif()
if(${USE_QRCODEGEN})
target_link_libraries(notcurses-core PRIVATE qrcodegen)
target_link_libraries(notcurses-core-static PRIVATE qrcodegen)
endif()

############################################################################
# libnotcurses (multimedia shared library+static library)
file(GLOB NCSRCS CONFIGURE_DEPENDS src/media/*.c src/media/*.cpp)
add_library(notcurses SHARED ${NCSRCS} ${COMPATSRC})
if(${USE_STATIC})
add_library(notcurses-static STATIC ${NCSRCS})
else()
add_library(notcurses-static STATIC EXCLUDE_FROM_ALL ${NCSRCS})
endif()
set_target_properties(notcurses PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
)
set_target_properties(notcurses-static PROPERTIES
  VERSION ${PROJECT_VERSION}
  OUTPUT_NAME notcurses
)
target_include_directories(notcurses
  PRIVATE
    include
    src
    src/lib
    "${PROJECT_BINARY_DIR}/include"
)
target_include_directories(notcurses-static
  PRIVATE
    include
    src
    src/lib
    "${PROJECT_BINARY_DIR}/include"
)
target_link_libraries(notcurses
  PUBLIC
    notcurses-core
)
target_link_libraries(notcurses-static
  PUBLIC
    notcurses-core-static
)
if(${USE_FFMPEG})
target_include_directories(notcurses
  PRIVATE
    "${AVCODEC_INCLUDE_DIRS}"
    "${AVFORMAT_INCLUDE_DIRS}"
    "${AVUTIL_INCLUDE_DIRS}"
    "${SWSCALE_INCLUDE_DIRS}"
)
target_include_directories(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_INCLUDE_DIRS}"
    "${AVFORMAT_STATIC_INCLUDE_DIRS}"
    "${AVUTIL_STATIC_INCLUDE_DIRS}"
    "${SWSCALE_STATIC_INCLUDE_DIRS}"
)
target_link_libraries(notcurses
  PRIVATE
    "${AVCODEC_LIBRARIES}"
    "${AVFORMAT_LIBRARIES}"
    "${SWSCALE_LIBRARIES}"
    "${AVUTIL_LIBRARIES}"
)
target_link_libraries(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARIES}"
    "${AVFORMAT_STATIC_LIBRARIES}"
    "${SWSCALE_STATIC_LIBRARIES}"
    "${AVUTIL_STATIC_LIBRARIES}"
)
target_link_directories(notcurses
  PRIVATE
    "${AVCODEC_LIBRARY_DIRS}"
    "${AVFORMAT_LIBRARY_DIRS}"
    "${SWSCALE_LIBRARY_DIRS}"
    "${AVUTIL_LIBRARY_DIRS}"
)
target_link_directories(notcurses-static
  PRIVATE
    "${AVCODEC_STATIC_LIBRARY_DIRS}"
    "${AVFORMAT_STATIC_LIBRARY_DIRS}"
    "${SWSCALE_STATIC_LIBRARY_DIRS}"
    "${AVUTIL_STATIC_LIBRARY_DIRS}"
)
elseif(${USE_OIIO})
target_include_directories(notcurses PUBLIC "${OIIO_INCLUDE_DIRS}")
target_include_directories(notcurses-static PUBLIC "${OIIO_STATIC_INCLUDE_DIRS}")
target_link_libraries(notcurses PRIVATE ${OIIO_LIBRARIES})
target_link_libraries(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARIES})
target_link_directories(notcurses PRIVATE ${OIIO_LIBRARY_DIRS})
target_link_directories(notcurses-static PRIVATE ${OIIO_STATIC_LIBRARY_DIRS})
endif()

############################################################################
# libnotcurses++ (C++ wrappers)
set(NCPP_SOURCES
  src/libcpp/FDPlane.cc
  src/libcpp/Menu.cc
  src/libcpp/MultiSelector.cc
  src/libcpp/NotCurses.cc
  src/libcpp/Plane.cc
  src/libcpp/Plot.cc
  src/libcpp/Reel.cc
  src/libcpp/Root.cc
  src/libcpp/Selector.cc
  src/libcpp/Subproc.cc
  src/libcpp/Tablet.cc
  src/libcpp/Utilities.cc
  )

add_library(notcurses++ SHARED ${NCPP_SOURCES})
if(${USE_STATIC})
add_library(notcurses++-static STATIC ${NCPP_SOURCES})
else()
add_library(notcurses++-static STATIC EXCLUDE_FROM_ALL ${NCPP_SOURCES})
endif()
set_target_properties(
  notcurses++-static PROPERTIES
  OUTPUT_NAME notcurses++
  )

set_target_properties(
  notcurses++ PROPERTIES
  VERSION ${PROJECT_VERSION}
  SOVERSION ${PROJECT_VERSION_MAJOR}
  OUTPUT_NAME "notcurses++")

set(NCPP_INCLUDE_DIRS
  include
    "${PROJECT_BINARY_DIR}/include"
    "${TERMINFO_INCLUDE_DIRS}"
  )

target_include_directories(notcurses++
  PRIVATE ${NCPP_INCLUDE_DIRS}
  )

target_include_directories(notcurses++-static
  PRIVATE ${NCPP_INCLUDE_DIRS}
  )

target_link_libraries(notcurses++
  PUBLIC
  notcurses)

set(NCPP_COMPILE_OPTIONS
  -Werror=format-security
  -Wnull-dereference
  -Wunused
  -Wno-c99-extensions
  -fno-strict-aliasing
  -ffunction-sections
  -fstack-protector
  -fno-rtti
  -fpic
  )

set(NCPP_COMPILE_DEFINITIONS_PUBLIC
  _GNU_SOURCE _DEFAULT_SOURCE
  )

target_compile_options(notcurses++
  PRIVATE
  ${NCPP_COMPILE_OPTIONS}
  )

target_compile_options(notcurses++-static
  PRIVATE
  ${NCPP_COMPILE_OPTIONS}
  )

target_compile_definitions(notcurses++
  PUBLIC
    ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
  )

target_compile_definitions(notcurses++-static
  PUBLIC
    ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
  )

file(GLOB NOTCURSES_HEADERS
  CONFIGURE_DEPENDS
  LIST_DIRECTORIES false
  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h

=== debian/changelog ===
notcurses (2.1.7+dfsg.1-2) unstable; urgency=medium

  * Source-only upload to initiate transition to testing.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 01 Feb 2021 01:22:42 -0500

notcurses (2.1.7+dfsg.1-1) unstable; urgency=medium

  * New upstream version.
  * libnotcurses-core has been split out of libnotcurses. The latter now
    only supplies multimedia support (using ffmpeg on Debian), with the
    remaining library functionality provided by libnotcurses-core. A
    binary linked against only libnotcurses-core.so requires no installed
    ffmpeg support, and thus a svelter dependency stack. The libnotcurses2
    package has thus been split into libnotcurses-core2 and libnotcurses2;
    libnotcurses-dev is now libnotcurses-core-dev and libnotcurses-dev.
  * "notcurses-view" has been renamed "ncplayer".

 -- Nick Black <dankamongmen@gmail.com>  Thu, 21 Jan 2021 03:23:34 -0500

=== debian/control ===
Source: notcurses
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends: cmake (>= 3.14),
               debhelper-compat (= 13),
               dh-python (>= 4.20191017),
               dh-sequence-python3,
               doctest-dev,
               libavformat-dev (>= 7:4.2.1),
               libavutil-dev (>= 7:4.2.1),
               libncurses-dev,
               libreadline-dev,
               libqrcodegen-dev (>= 1.5.0),
               libswscale-dev (>= 7:4.2.1),
               libunistring-dev,
               pandoc (>= 1.19.2.4),
               pkg-config,
               python3-cffi (>= 1.13.2),
               python3-dev,
               python3-pip (>= 20.0),
               python3-pypandoc,
               python3-setuptools (>= 44.0.0)
Standards-Version: 4.5.1
Section: libs
X-Python3-Version: >= 3.7
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/Notcurses
Vcs-Browser: https://salsa.debian.org/debian/notcurses
Vcs-Git: https://salsa.debian.org/debian/notcurses.git

Package: libnotcurses++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses++2 (= ${binary:Version}),
         libnotcurses-dev (>= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (C++ development)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for C++ development using Notcurses.

Package: libnotcurses++2
Architecture: any
Multi-Arch: same
Recommends: ncurses-term
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libnotcurses++1 (>= 2)
Breaks: libnotcurses++1 (>= 2)
Description: Character graphics and TUI library (C++)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.

Package: libnotcurses-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses2 (= ${binary:Version}),
         ${misc:Depends}
Recommends: libnotcurses-dev
Replaces: libnotcurses-dev (<< 2.1.6)
Breaks: libnotcurses-dev (<< 2.1.6)
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using Notcurses. They
 do not include multimedia support; that requires libnotcurses-dev.

Package: libnotcurses-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnotcurses2 (= ${binary:Version}),
         libnotcurses-core-dev (>= ${binary:Version}),
         ${misc:Depends}
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using Notcurses. This
 package installs multimedia support atop libnotcurses-core-dev.

Package: libnotcurses-core2
Architecture: any
Multi-Arch: same
Recommends: libnotcurses2,
            ncurses-term
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libnotcurses1 (>= 2),
          libnotcurses2 (<< 2.1.6)
Breaks: libnotcurses1 (>= 2),
        libnotcurses2 (<< 2.1.6)
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 This core library lacks multimedia support. For that,
 libnotcurses2 must be installed.

Package: libnotcurses2
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Replaces: libnotcurses1 (>= 2)
Breaks: libnotcurses1 (>= 2)
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 This package provides multimedia support via ffmpeg.

Package: notcurses-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends: desktop-base,
         notcurses-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ncurses-term,
            python3-notcurses (>= ${source:Version})
Description: Character graphics and TUI library demos
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These utilities from the Notcurses project include notcurses-demo
 (a demonstration of various libnotcurses capabilities), ncplayer
 (a character mode multimedia player), ncls (a file lister that
 displays multimedia), and other tools. Unit tests are furthermore
 bundled as notcurses-tester.

Package: notcurses-data
Architecture: all
Multi-Arch: foreign
Section: graphics
Depends: ${misc:Depends}
Recommends: ncurses-term
Description: Multimedia used by notcurses-bin
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 This package contains multimedia used by notcurses-demo
 and notcurses-tester from the notcurses-bin package.

Package: python3-notcurses
Section: python
Architecture: any
Multi-Arch: no
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
Provides: ${python3:Provides}
Replaces: notcurses-bin (<< 1.6)
Breaks: notcurses-bin (<< 1.6)
Description: Character graphics and TUI library (Python)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for Python development using Notcurses.
 The notcurses-pydemo script verifies these Python wrappers.

## notcurses 2.1.8+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.7
+project(notcurses VERSION 2.1.8
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.1.8+dfsg.1-1) unstable; urgency=medium

  * New upstream version
  * Update copyrights for ncart.c, extracted from neofetch

 -- Nick Black <dankamongmen@gmail.com>  Wed, 03 Feb 2021 08:39:12 -0500

=== debian/control ===
--- 
+++ 
@@ -58,17 +58,15 @@
 Section: libdevel
 Architecture: any
 Multi-Arch: same
-Depends: libnotcurses2 (= ${binary:Version}),
+Depends: libnotcurses-core2 (= ${binary:Version}),
          ${misc:Depends}
 Recommends: libnotcurses-dev
-Replaces: libnotcurses-dev (<< 2.1.6)
-Breaks: libnotcurses-dev (<< 2.1.6)
+Replaces: libnotcurses-dev (<< 2.1.7)
+Breaks: libnotcurses-dev (<< 2.1.7)
 Description: Character graphics and TUI library (development)
  Notcurses facilitates the creation of modern TUI programs, making
- full use of Unicode and 24-bit TrueColor. Its API is similar
- to that of NCURSES, but extends that with z-buffering, rendering
- of images and video using ffmpeg, alpha blending, widgets, palette
- fades, resize awareness, and multithreading support.
+ full use of Unicode and 24-bit TrueColor. This development
+ package covers the Notcurses core library.
  .
  These files are necessary for C development using Notcurses. They
  do not include multimedia support; that requires libnotcurses-dev.
@@ -98,15 +96,12 @@
 Pre-Depends: ${misc:Pre-Depends}
 Depends: ${misc:Depends}, ${shlibs:Depends}
 Replaces: libnotcurses1 (>= 2),
-          libnotcurses2 (<< 2.1.6)
+          libnotcurses2 (<< 2.1.7)
 Breaks: libnotcurses1 (>= 2),
-        libnotcurses2 (<< 2.1.6)
+        libnotcurses2 (<< 2.1.7)
 Description: Character graphics and TUI library
  Notcurses facilitates the creation of modern TUI programs, making
- full use of Unicode and 24-bit TrueColor. Its API is similar
- to that of NCURSES, but extends that with z-buffering, rendering
- of images and video using ffmpeg, alpha blending, widgets, palette
- fades, resize awareness, and multithreading support.
+ full use of Unicode and 24-bit TrueColor.
  .
  This core library lacks multimedia support. For that,
  libnotcurses2 must be installed.
@@ -131,11 +126,11 @@
 Architecture: any
 Multi-Arch: foreign
 Section: graphics
-Depends: desktop-base,
-         notcurses-data (= ${source:Version}),
+Depends: notcurses-data (= ${source:Version}),
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: ncurses-term,
+Recommends: desktop-base,
+            ncurses-term,
             python3-notcurses (>= ${source:Version})
 Description: Character graphics and TUI library demos
  Notcurses facilitates the creation of modern TUI programs,

## notcurses 2.2.1+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.1.8
+project(notcurses VERSION 2.2.1
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)

=== debian/changelog ===
notcurses (2.2.1+dfsg.1-1) unstable; urgency=medium

  * New upstream version, fixes brown-bag failure to discover
    UTF8 properly in Direct Mode.

 -- Nick Black <dankamongmen@gmail.com>  Tue, 09 Feb 2021 19:37:35 -0500

notcurses (2.2.0+dfsg.1-1) unstable; urgency=medium

  * New upstream version

 -- Nick Black <dankamongmen@gmail.com>  Mon, 08 Feb 2021 09:37:54 -0500

## notcurses 2.2.2+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.2.1
+project(notcurses VERSION 2.2.2
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -46,8 +46,8 @@
   set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE
     STRING "Choose the build mode." FORCE)
 endif()
-string(APPEND CMAKE_C_FLAGS_DEBUG " -O0")
-string(APPEND CMAKE_CXX_FLAGS_DEBUG " -O0")
+string(APPEND CMAKE_C_FLAGS_DEBUG " -Og")
+string(APPEND CMAKE_CXX_FLAGS_DEBUG " -Og")
 if("${USE_COVERAGE}")
   if(NOT "${CMAKE_C_COMPILER_ID}" MATCHES "(Apple)?[Cc]lang")
     message(FATAL_ERROR "USE_COVERAGE was on but CC isn't clang")

=== debian/changelog ===
notcurses (2.2.2+dfsg.1-1) unstable; urgency=medium

  * New upstream version. Fixes attribute reset on initial read
    in emulators lacking "oc" capability, and cursor placement on
    exit from direct mode.

 -- Nick Black <dankamongmen@gmail.com>  Thu, 18 Feb 2021 07:12:31 -0500

## notcurses 2.2.3+dfsg.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,6 @@
 # 3.14.0 introduced NAME_WLE
 cmake_minimum_required(VERSION 3.14.0)
-project(notcurses VERSION 2.2.2
+project(notcurses VERSION 2.2.3
   DESCRIPTION "Blingful UI for modern terminal emulators"
   HOMEPAGE_URL "https://nick-black.com/dankwiki/index.php/notcurses"
   LANGUAGES C CXX)
@@ -145,6 +145,7 @@
   PRIVATE
     include
     src
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_INCLUDE_DIRS}"
     "${READLINE_INCLUDE_DIRS}"
@@ -153,6 +154,7 @@
   PRIVATE
     include
     src
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
     "${TERMINFO_STATIC_INCLUDE_DIRS}"
     "${READLINE_STATIC_INCLUDE_DIRS}"
@@ -227,6 +229,7 @@
     include
     src
     src/lib
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
 )
 target_include_directories(notcurses-static
@@ -234,6 +237,7 @@
     include
     src
     src/lib
+    "${CMAKE_REQUIRED_INCLUDES}"
     "${PROJECT_BINARY_DIR}/include"
 )
 target_link_libraries(notcurses
@@ -384,7 +388,3 @@
     ${NCPP_COMPILE_DEFINITIONS_PUBLIC}
   )
 
-file(GLOB NOTCURSES_HEADERS
-  CONFIGURE_DEPENDS
-  LIST_DIRECTORIES false
-  ${PROJECT_SOURCE_DIR}/include/notcurses/*.h

=== debian/changelog ===
notcurses (2.2.3+dfsg.1-1) unstable; urgency=medium

  * New upstream version, introducing nctree and NCBLIT_PIXEL.

 -- Nick Black <dankamongmen@gmail.com>  Mon, 08 Mar 2021 07:13:10 -0500

=== debian/control ===
Source: notcurses
Priority: optional
Maintainer: Nick Black <dankamongmen@gmail.com>
Build-Depends:
 cmake (>= 3.14),
 debhelper-compat (= 13),
 dh-python (>= 4.20191017),
 dh-sequence-python3,
 doctest-dev,
 libavformat-dev (>= 7:4.2.1),
 libavutil-dev (>= 7:4.2.1),
 libncurses-dev,
 libqrcodegen-dev (>= 1.5.0),
 libreadline-dev,
 libswscale-dev (>= 7:4.2.1),
 libunistring-dev,
 pandoc (>= 1.19.2.4),
 pkg-config,
 python3-cffi (>= 1.13.2),
 python3-dev,
 python3-pip (>= 20.0),
 python3-pypandoc,
 python3-setuptools (>= 44.0.0),
Standards-Version: 4.5.1
Section: libs
X-Python3-Version: >= 3.7
Rules-Requires-Root: no
Homepage: https://nick-black.com/dankwiki/index.php/Notcurses
Vcs-Browser: https://salsa.debian.org/debian/notcurses
Vcs-Git: https://salsa.debian.org/debian/notcurses.git

Package: libnotcurses++-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses++2 (= ${binary:Version}),
 libnotcurses-dev (>= ${binary:Version}),
 ${misc:Depends},
Description: Character graphics and TUI library (C++ development)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for C++ development using Notcurses.

Package: libnotcurses++2
Architecture: any
Multi-Arch: same
Recommends:
 ncurses-term,
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses++1 (>= 2),
Breaks:
 libnotcurses++1 (>= 2),
Description: Character graphics and TUI library (C++)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.

Package: libnotcurses-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses-core2 (= ${binary:Version}),
 ${misc:Depends},
Recommends:
 libnotcurses-dev,
Replaces:
 libnotcurses-dev (<< 2.1.7),
Breaks:
 libnotcurses-dev (<< 2.1.7),
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. This development
 package covers the Notcurses core library.
 .
 These files are necessary for C development using Notcurses. They
 do not include multimedia support; that requires libnotcurses-dev.

Package: libnotcurses-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libnotcurses-core-dev (>= ${binary:Version}),
 libnotcurses2 (= ${binary:Version}),
 ${misc:Depends},
Description: Character graphics and TUI library (development)
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 These files are necessary for C development using Notcurses. This
 package installs multimedia support atop libnotcurses-core-dev.

Package: libnotcurses-core2
Architecture: any
Multi-Arch: same
Recommends:
 libnotcurses2,
 ncurses-term,
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses1 (>= 2),
 libnotcurses2 (<< 2.1.7),
Breaks:
 libnotcurses1 (>= 2),
 libnotcurses2 (<< 2.1.7),
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor.
 .
 This core library lacks multimedia support. For that,
 libnotcurses2 must be installed.

Package: libnotcurses2
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Replaces:
 libnotcurses1 (>= 2),
Breaks:
 libnotcurses1 (>= 2),
Description: Character graphics and TUI library
 Notcurses facilitates the creation of modern TUI programs, making
 full use of Unicode and 24-bit TrueColor. Its API is similar
 to that of NCURSES, but extends that with z-buffering, rendering
 of images and video using ffmpeg, alpha blending, widgets, palette
 fades, resize awareness, and multithreading support.
 .
 This package provides multimedia support via ffmpeg.

Package: notcurses-bin
Architecture: any
Multi-Arch: foreign
Section: graphics
Depends:
 notcurses-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 desktop-base,
 ncurses-term,
 python3-notcurses (>= ${source:Version}),
Description: Character graphics and TUI library demos
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These utilities from the Notcurses project include notcurses-demo
 (a demonstration of various libnotcurses capabilities), ncplayer
 (a character mode multimedia player), ncls (a file lister that
 displays multimedia), and other tools. Unit tests are furthermore
 bundled as notcurses-tester.

Package: notcurses-data
Architecture: all
Multi-Arch: foreign
Section: graphics
Depends:
 ${misc:Depends},
Recommends:
 ncurses-term,
Description: Multimedia used by notcurses-bin
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 This package contains multimedia used by notcurses-demo
 and notcurses-tester from the notcurses-bin package.

Package: python3-notcurses
Section: python
Architecture: any
Multi-Arch: no
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Provides:
 ${python3:Provides},
Replaces:
 notcurses-bin (<< 1.6),
Breaks:
 notcurses-bin (<< 1.6),
Description: Character graphics and TUI library (Python)
 Notcurses facilitates the creation of modern TUI programs,
 making full use of Unicode and 24-bit TrueColor. It presents
 an API similar to that of Curses, and rides atop Terminfo.
 .
 These files are necessary for Python development using Notcurses.
 The notcurses-pydemo script verifies these Python wrappers.

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
DEB_BUILD_MAINT_OPTIONS=reproducible=+fixfilepath

export DEB_BUILD_MAINT_OPTIONS=hardening=+all reproducible=+fixfilepath
export PYBUILD_NAME=notcurses
export PYBUILD_DIR=cffi
export PYBUILD_DESTDIR=debian/python3-notcurses

CFLAGS += -ffile-prefix-map=$(CURDIR)=.

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DDFSG_BUILD=on -DUSE_POC=off

override_dh_auto_build:
	dh_auto_build
	CFLAGS="$(CFLAGS) -I$(CURDIR)/include" LDFLAGS="$(LDFLAGS) \
		-L$(CURDIR)/obj-$(DEB_HOST_GNU_TYPE)" pybuild --build

override_dh_auto_install:
	dh_auto_install -B $(BUILDDIR)
	pybuild --install

=== debian/tests/control ===
# The CI pipeline on salsa.debian.org doesn't appear to export a TERM variable
# to the autopkgtest environment. We thus manually use TERM=xterm for all
# commands. They'd otherwise fail out, or (worse) not actually test anything.

# These two tests are currently marked flaky due to poorly-understood problems
# involving output of emoji when run in the autopkgtest suite FIXME.

# Basic unit test suite, but run with installed binary
Test-Command: TERM=xterm notcurses-tester
Depends: notcurses-bin
Restrictions: allow-stderr, flaky
Features: test-name=unittests

# Execute notcurses-demo with:
#  -c: seed PRNG with known constant for semi-reproducible timings
#  -m2: use 2-cell margins on all sides (to test margins)
#  -d0: delay multiplier of 0 (no artificial delays)
Test-Command: TERM=xterm notcurses-demo -c -m2 -d0
Depends: notcurses-bin
Restrictions: allow-stderr, flaky
Features: test-name=demo

# Execute notcurses-pydemo
Test-Command: TERM=xterm notcurses-pydemo
Depends: python3-notcurses
Restrictions: allow-stderr
Features: test-name=pydemo

=== debian/watch ===
version=4

opts="pgpsigurlmangle=s/archive\/(v\d\S+)\.tar\.gz/releases\/download\/$1\/$1\.tar\.gz\.asc/,\
      dversionmangle=s/\+dfsg(\.?\d+)?$//,\
      repacksuffix=+dfsg.1, \
      filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%notcurses-$1.tar.gz%" \
   https://github.com/dankamongmen/notcurses/releases (?:.*?/)?v?(\d[\d.]*)\.tar\.gz \
   debian uupdate
